# 被执法人推理

## 功能
对视频的每一帧，处理topN个大框目标：
- 如果目标类别是car，则用ocr提取车牌号；
- 如果目标类别是person，先用交警模型判断是否是交警，如果不是交警，则对人脸图像清晰度大于等于一定阈值的，记录该人脸的embedding；

返回每一帧处理得到的所有车牌号列表（去重）和所有人脸embedding列表；

## 性能测试
| 视频名 |   显存   | gpu使用率 | 处理帧数 |  耗时   | half  | 跳帧 | 检测结果（人脸/车牌数） |
| :----: | :------: | :------: | :------: | :-----: | :---: | :--: | :---------------------: |
| 2.MP4  | 2.0G左右 |   50%+    |  26975   | 166.57s | False |  -   |          145/0          |
| 2.MP4  | 1.9G左右 |   50%+    |  26975   | 162.65s | True  |  -   |          145/0          |
| 2.MP4  | 2.0G左右 |   40%+    |   2997   | 28.79s  | False |  9   |          17/0           |
| 2.MP4  | 1.9G左右 |   40%+    |   2997   | 28.83s  | True  |  9   |          17/0           |
| 1.MP4  | 2.0G左右 |   50%+    |  26991   | 178.69s | False |  -   |          578/0          |
| 1.MP4  | 2.0G左右 |   50%+    |  26991   | 176.29s | True  |  -   |          578/0          |
| 1.MP4  | 2.0G左右 |   40%+    |   2999   | 30.12s  | False |  9  |          60/0           |
| 1.MP4  | 2.0G左右 |   40%+    |   2999   | 30.04s  | True  |  9  |          60/0           |

### float16推理
- 如果不跳帧，半精度推理后速度略有提升；
- 如果本身处理帧数少，速度没啥影响；
- 对检测结果也几乎没有影响；

### 跳帧
- 相比不跳帧，耗时明显减少，筛选得到的结果也明显减少；
- gpu使用率降低；

### 更新
- 20240125：对被执法车加入truck，motorcycle，bus类别，增加摩托车车牌识别规则（车牌内容格式为两行）；

### 部分视频无法检测人或车原因
- 人脸相似个数太少，导致合并时间段时被过滤；
- yolo对车目标检测置信度太低，或直接没有检测到，导致不会进行下一步ocr检测；
- 车牌不够清晰导致ocr检测无结果；