#!/usr/bin/env python
# -*- coding: UTF-8 -*-
"""
@Project ：yolo_demos 
@File ：config.py
@IDE ：PyCharm 
@Author ：zjj
@Date ：2023/9/22 10:19 
"""

# yolo 语义分割模型
from pathlib import Path

PERSON = "person"
CAR = "car"
TRUCK = 'truck'
MOTORCYCLE = 'motorcycle'
BUS = 'bus'
MOTOR_VEHICLE = 'car_related'
MOTOR_VEHICLE_LIST = [CAR, TRUCK, MOTORCYCLE, BUS]
LABEL_NAMES = {0: PERSON, 2: CAR, 3: MOTORCYCLE, 5: BUS, 7: TRUCK}

# 过程中保存图片路径
# SAVE_BASE_DIR = Path('/home/TP/PMP/media/tp_result')
# SAVE_BASE_DIR = Path(os.getenv("OTHER_SAVING_PATH", "../media/tp_result"))


# BASE_MODEL_PATH = Path(__file__).parent.parent.parent / "models"
# 临时路径
BASE_MODEL_PATH = Path('/mnt/large/zhoujinjuan_data/data/Filter_Object_models/models')

# yolo detect model path
DETECT_MODEL = (BASE_MODEL_PATH / "yolov8n.pt").as_posix()
SEGMENT_MODEL = (BASE_MODEL_PATH / "yolov8n-seg.pt").as_posix()

# scrfd模型
SCRFD_PATH_DICT = {
    "onnx": (BASE_MODEL_PATH / "scrfd_500m_bnkps_shape640x640.onnx").as_posix(),
    "trt": (BASE_MODEL_PATH / "scrfd_500m_bnkps_shape640x640.trt").as_posix(),
}
# insightface模型
INSIGHTFACE_PATH_DICT = {
    "onnx": (BASE_MODEL_PATH / "partial_fc_glint360k_r100.onnx").as_posix(),
    "trt": (BASE_MODEL_PATH / "partial_fc_glint360k_r100.trt").as_posix(),
}

# 交警模型
POLICE_PATH = (BASE_MODEL_PATH / "TP_police.onnx").as_posix()

# track 配置文件
TRACK_YAML = (BASE_MODEL_PATH / "my_botsort.yaml").as_posix()

# articulation_model_path articulation_range_path
ARTICULATION_MODEL_PATH = (BASE_MODEL_PATH / "brisque_model_live.yml").as_posix()
ARTICULATION_RANGE_PATH = (BASE_MODEL_PATH / "brisque_range_live.yml").as_posix()

# todo 帧数阈值设置要结合帧率，以及是否跳帧
# 大框图数量阈值
# PERSON: 10, CAR: 200  LICENSE_COUNT_THRESHOLD = 3  由于3帧检测一次，所以值除以3

# ***********no use************
BIG_FRAME_NUM = {PERSON: 3, CAR: 30}
# 车牌号帧数阈值
LICENSE_COUNT_THRESHOLD = 3
# 人脸保存相似度阈值，相似度大于阈值则不保存
FACE_SAVE_THRESHOLD = 0.5
# 文件夹之间人脸相似阈值，大于阈值认为相似
FACE_COMPARE_THRESHOLD = 0.3
# 两个文件夹相似文件数占原文件夹总文件数比例超过0.5， 则认为两个文件夹相似
DIR_RATIO_THRESHOLD = 0.5
# person 返回topn
TOPN = {PERSON: 5, CAR: 2}
# ***********no use************


# 人脸检测阈值 0.85
FACE_THRESHOLD = 0.83
# 目标检测置信度阈值 0.8
DETECT_CONF_THRESHOLD = 0.6
# 框面积阈值 todo 存在有的被执法人就是离镜头远或者模型画的框小 15
BOX_AREA_THRESHOLD = 5

# 每一帧内处理面积top2个大框图
TOPN_AREA = 2

# 目标检测框和交警框iou超过阈值则认为该目标是交警
POLICE_IOU = 0.5

# 人脸清晰度阈值 0-100之间
ARTICULATION_THD = 30

# 摩托车两行车牌文字box的接近程度（上面box的ymax和下面box的ymin差值绝对值）
DELTA_Y = 10