#!/usr/bin/env python
# -*- coding: UTF-8 -*-
'''
@Project ：Filter_Object 
@File ：utils_test.py
@IDE ：PyCharm 
@Author ：zjj
@Date ：2024/1/25 9:56 
'''
import unittest

import cv2

from algs import ocr_alg
from utils import parse_moto_number, predict_ocr, parse_plate_number


class UtilsTest(unittest.TestCase):

    @staticmethod
    def test_predict_ocr():
        frame = cv2.imread('data/truck1.png')
        result = predict_ocr(frame)
        print(result)

    @staticmethod
    def test_parse_plate_number():
        text = '苏J7272Z'
        result = parse_plate_number(text)
        print(result)

    @staticmethod
    def test_parse_moto_number():
        frame = cv2.imread('data/moto2.jpg')
        ocr_result = ocr_alg.ocr_predict(frame)
        moto_list = parse_moto_number(ocr_result)
        print(moto_list)